/*
 * This file is part of ViaFabricPlus - https://github.com/FlorianMichael/ViaFabricPlus
 * Copyright (C) 2021-2023 FlorianMichael/EnZaXD
 * Copyright (C) 2023      RK_01/RaphiMC and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.florianmichael.viafabricplus.fixes.replacement;

import com.mojang.authlib.yggdrasil.response.KeyPairResponse;

import java.nio.ByteBuffer;

/*
This class is part of the AuthLib, we are overwriting this class to add a new field.
 */

public record KeyPairResponse1_19_0(
        KeyPairResponse.KeyPair keyPair,
        ByteBuffer publicKeySignatureV2,
        ByteBuffer publicKeySignature /* removed in 1.20-rc1 */,
        String expiresAt,
        String refreshedAfter) {
}
